class Panel::PersonalDiploma::BackEnd::DiplomasController < OrbitBackendController
  include AdminHelper
  include OrbitControllerLib::DivisionForDisable
  
  before_filter :authenticate_user!
  before_filter :force_order_for_visitor,:only=>[:index,:show]
  before_filter :force_order_for_user,:except => [:index,:show]
  # before_filter :for_app_manager,:except => [:index,:show] 
  
  def index
  
  @filter = params[:filter]
  new_filter = params[:new_filter]

  if @filter && params[:clear]
    @filter.delete(params[:type])
  elsif @filter && new_filter
    if @filter.has_key?(new_filter[:type]) && @filter[new_filter[:type]].include?(new_filter[:id].to_s)
      @filter[new_filter[:type]].delete(new_filter[:id].to_s)
    elsif @filter.has_key?(new_filter[:type])
      @filter[new_filter[:type]] << new_filter[:id].to_s
    else
      @filter.merge!({new_filter[:type] => [new_filter[:id].to_s]})
    end
  elsif new_filter
    @filter = {new_filter[:type] => [new_filter[:id].to_s]}
  end
  
  
  @diplomas = (params[:sort] || @filter) ? get_sorted_and_filtered("diploma") : get_viewable("diploma")

  get_tags

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @diplomas }
      format.js
    end
  end

  def diploma_setting
  	
    get_tags
	
  end

  # GET /diplomas/1
  # GET /diplomas/1.xml
  def show
    @diploma = Diploma.find(params[:id])
    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @diploma }
    end
  end

  # GET /diplomas/new
  # GET /diplomas/new.xml
  def new
  
    @diploma = Diploma.new 
	
    get_tags

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @diploma }
    end
  end

  # GET /diplomas/1/edit
  def edit
    @diploma = Diploma.find(params[:id]) 
	
    get_tags
  end

  # POST /diplomas
  # POST /diplomas.xml
  def create
  
	get_tags
  
    @diploma = Diploma.new(params[:diploma])
	
	if params[:diploma][:user_id]
      @diploma.create_user_id = params[:diploma][:user_id]
      @diploma.update_user_id = params[:diploma][:user_id]
    else
	  @diploma.create_user_id = current_user.id
      @diploma.update_user_id = current_user.id
    end

    respond_to do |format|
      if @diploma.save
	  
		if params[:diploma][:user_id]
          format.html { redirect_to(admin_users_new_interface_url(:id=>params[:diploma][:user_id],:show_plugin_profile=>'Diploma')) }
        else
		  format.html { redirect_to(panel_personal_diploma_back_end_diplomas_url) }
        end
		
        format.xml  { render :xml => @diploma, :status => :created, :location => @diploma }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @diploma.errors, :status => :unprocessable_entity }
      end
    end
  end
  
  # PUT /diplomas/1
  # PUT /diplomas/1.xml
  def update
  
    @diploma = Diploma.find(params[:id])
	
    @diploma.update_user_id = current_user.id
	
	params[:diploma][:tag_ids] ||=[]

    respond_to do |format|
      if @diploma.update_attributes(params[:diploma])
        format.html { redirect_to(panel_personal_diploma_back_end_diplomas_url) }
		# format.js  { render 'toggle_enable' }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @diploma.errors, :status => :unprocessable_entity }
      end
    end
  end
  
  # DELETE /diplomas/1
  # DELETE /diplomas/1.xml
  def destroy
    @diploma = Diploma.find(params[:id])
    @diploma.destroy

    respond_to do |format|
      format.html { redirect_to(panel_personal_diploma_back_end_diplomas_url) }
      # format.xml  { head :ok }
      format.js
    end
  end

  def delete
    if params[:ids]
      diplomas = Diploma.any_in(:_id => params[:ids]).delete_all
    end
    redirect_to panel_personal_diploma_back_end_diplomas_url(:direction => params[:direction], :sort => params[:sort], :sort_options => params[:sort_options])
  end
  
  protected
 

  # def get_index_categories(id = nil)
  #   @bulletin_categorys = []
  #   if(is_manager? || is_admin?)
  #     @bulletin_categorys = (id ? BulletinCategory.admin_manager_all.find(id).to_a : BulletinCategory.admin_manager_all)
  #   elsif is_sub_manager?
  #     @bulletin_categorys = BulletinCategory.all
  #   end
  #   @bulletin_categorys
  # end


  # def get_categorys(id = nil)
  #   @diploma_categorys = []
  #   if(is_manager? || is_admin?)
  #     @diploma_categorys = (id ? DiplomaCategory.admin_manager_all.find(id).to_a : DiplomaCategory.admin_manager_all))
  #   elsif is_sub_manager?
  #     @diploma_categorys = DiplomaCategory.all.authed_for_user(current_user,'edit')
  #   end
  #   if @diploma_categorys.empty? && params[:action] != "index"
  #       flash[:alert] = t("announcement.error.no_avilb_cate_for_posting")
  #       redirect_to :action => :index
  #   end
  # end
  
  def get_tags
  	module_app = ModuleApp.first(:conditions => {:key => 'personal_diploma'})
  	@tags = Tag.all(:conditions => {:module_app_id => module_app.id})
  end
  
end
